package dev.shadowsoffire.apotheosis.adventure.commands;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.mojang.brigadier.arguments.ArgumentType;
import com.mojang.brigadier.arguments.FloatArgumentType;
import com.mojang.brigadier.arguments.StringArgumentType;
import com.mojang.brigadier.builder.LiteralArgumentBuilder;
import com.mojang.brigadier.context.CommandContext;
import com.mojang.brigadier.exceptions.CommandSyntaxException;
import com.mojang.brigadier.suggestion.SuggestionProvider;
import com.mojang.brigadier.suggestion.SuggestionsBuilder;
import java.util.Arrays;
import java.util.Locale;
import java.util.concurrent.CompletableFuture;
import net.minecraft.commands.CommandSourceStack;
import net.minecraft.commands.Commands;
import net.minecraft.commands.SharedSuggestionProvider;
import net.minecraft.commands.arguments.ResourceLocationArgument;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.server.level.ServerPlayer;
import net.minecraft.world.entity.EquipmentSlot;
import net.minecraft.world.entity.ai.attributes.Attribute;
import net.minecraft.world.entity.ai.attributes.AttributeModifier;
import net.minecraft.world.item.ItemStack;
import net.minecraftforge.registries.ForgeRegistries;

public class ModifierCommand {
  public static final SuggestionProvider<CommandSourceStack> SUGGEST_OP;
  
  public static final SuggestionProvider<CommandSourceStack> SUGGEST_SLOT;
  
  public static final SuggestionProvider<CommandSourceStack> SUGGEST_ATTRIB;
  
  static {
    SUGGEST_OP = ((ctx, builder) -> SharedSuggestionProvider.m_82981_(Arrays.<AttributeModifier.Operation>stream(AttributeModifier.Operation.values()).map(Enum::name), builder));
    SUGGEST_SLOT = ((ctx, builder) -> SharedSuggestionProvider.m_82981_(Arrays.<EquipmentSlot>stream(EquipmentSlot.values()).map(Enum::name), builder));
    SUGGEST_ATTRIB = ((ctx, builder) -> SharedSuggestionProvider.m_82981_(ForgeRegistries.ATTRIBUTES.getKeys().stream().map(ResourceLocation::toString), builder));
  }
  
  public static void register(LiteralArgumentBuilder<CommandSourceStack> root) {
    root.then(((LiteralArgumentBuilder)Commands.m_82127_("modifier").requires(c -> c.m_6761_(2))).then(Commands.m_82129_("attribute", (ArgumentType)ResourceLocationArgument.m_106984_()).suggests(SUGGEST_ATTRIB).then(Commands.m_82129_("op", (ArgumentType)StringArgumentType.word())
            .suggests(SUGGEST_OP).then(Commands.m_82129_("value", (ArgumentType)FloatArgumentType.floatArg()).then(Commands.m_82129_("slot", (ArgumentType)StringArgumentType.word()).suggests(SUGGEST_SLOT).executes(c -> {
                    ServerPlayer serverPlayer = ((CommandSourceStack)c.getSource()).m_81375_();
                    Attribute attrib = (Attribute)ForgeRegistries.ATTRIBUTES.getValue((ResourceLocation)c.getArgument("attribute", ResourceLocation.class));
                    AttributeModifier.Operation op = AttributeModifier.Operation.valueOf(((String)c.getArgument("op", String.class)).toUpperCase(Locale.ROOT));
                    EquipmentSlot slot = EquipmentSlot.valueOf(((String)c.getArgument("slot", String.class)).toUpperCase(Locale.ROOT));
                    float value = ((Float)c.getArgument("value", Float.class)).floatValue();
                    ItemStack stack = serverPlayer.m_21205_();
                    stack.m_41643_(attrib, new AttributeModifier("cmd-generated-modif", value, op), slot);
                    return 0;
                  }))))));
  }
}
